//---090419---14 профилей tft SPI 2.4" 320*240---Serial Port Plotter 1.2.0---//
//---Dmitrish особая благодарность и признательность!---//

#include <SPI.h>
//#include <Wire.h>
#include <EEPROM.h>
#include "Adafruit_GFX.h"
#include "Adafruit_ILI9341.h"

// Для Adafruit shield это значения по умолчанию.
// Использовать аппаратный SPI (на Uno, #13, #12, #11) и выше для CS / DC
// При использовании breakout измените контакты по желанию
// 1 TFT_VCC -> 3V3 //через LD01117-3v3 это для моего дисплея
// 2 TFT_GND -> GND
// 3 TFT_CS  -> D10 //через делитель 1кОм/2кОм
// 4 TFT_RST -> RST_pin // на D8 не работает, повесил на RST через резистор 1кОм
// 5 TFT_DC  -> D9  //через делитель 1кОм/2кОм
// 6 TFT_MOSI-> D11 //через делитель 1кОм/2кОм
// 7 TFT_SCK -> D13 //через делитель 1кОм/2кОм
// 8 TFT_LED -> 3V3 //через LD01117-3v3
// 9 TFT_MISO-> N.C.
// D12-> N.C.
#define TFT_DC 9
#define TFT_CS 10
#define Bgcolor 0xC618
#define ILI9341_NAVY            0x000F 
#define ILI9341_DARKGREEN       0x03E0 
Adafruit_ILI9341 tft = Adafruit_ILI9341();

//---секция ПИД---//
byte kp1; //пропорциональный коэффициент ПИД для ВИ
byte ki1; //интегральный коэффициент ПИД для ВИ
byte kd1; //дифференциальный коэффициент ПИД для ВИ
byte kp2; //пропорциональный коэффициент ПИД для НИ
byte ki2; //интегральный коэффициент ПИД для НИ
byte kd2; //дифференциальный коэффициент ПИД для НИ
double  Input1; //текущая температура(измеренная max6675) ВИ
byte Output1; //выход ПИД регулятора ВИ
byte Setpoint1; //установленная температура(уставка) ВИ
double  Input2; //текущая температура(измеренная max6675) НИ
byte Output2; //установленная температура(уставка) НИ
int Setpoint2; //выход ПИД регулятора НИ
#define i_min 0.0 //минимум И составляющей
#define i_max 100.0 //максимум И составляющей
float integra, integra2;
//---секция ПИД---//

//---MAX6675 functions---//
double max6675_read_temp (int CLK, int CS, int SO)
{ char i;
  int tmp = 0;
  digitalWrite(CS, LOW); //CS = 0;                            //Stop a conversion in progress
  asm volatile
  (
    " nop"        "\n\t"
  );
  for (i = 15; i >= 0; i--)
  { digitalWrite(CLK, HIGH);
    asm volatile
    (
      " nop"        "\n\t"
    );
    if ( digitalRead(SO))
      tmp |= (1 << i);
    digitalWrite(CLK, LOW);
    asm volatile
    (
      " nop"        "\n\t"
    );
  }
  digitalWrite(CS, HIGH);
  if (tmp & 0x4) {
    return NAN;
  } else
    return ((tmp >> 3)) * 0.25;
}
//---MAX6675 functions---//

//---секция алгоритма Брезенхема---//
int er1 = 1;  //переменная для расчета переполнения в алгоритме Брезенхема для ВИ
int er2 = 1;  //переменная для расчета переполнения в алгоритме Брезенхема для НИ
int reg1;     //промежуточная переменная для алгоритма Брезенхема для ВИ
int reg2;     //промежуточная переменная для алгоритма Брезенхема для НИ
boolean out1; //выход импульса управления ВИ алгоритма Брезенхема
boolean out2; //выход импульса управления НИ алгоритма Брезенхема
//---секция алгоритма Брезенхема---//

//---секция нагревателей---//
//переменные для установки мощности нагревателей
byte pwr_TOP;     //максимальная мощность верхнего нагревателя
byte pwr_BOTTOM;  //максимальная мощность нижнего нагревателя
//RelayPin "1"-ВЕРХНИЙ нагреватель
//RelayPin "2"-НИЖНИЙ нагреватель
#define RelayPin1 A4  //назначаем пин "ВЕРХНЕГО" нагревателя
#define RelayPin2 A5  //назначаем пин "НИЖНЕГО" нагревателя
//---секция нагревателей---//

//---секция кнопок---//
//Назначаем пины кнопок управления
byte upSwitchPin     = A0;
byte downSwitchPin   = A1;
byte cancelSwitchPin = A2;
byte okSwitchPin     = A3;
//состояние кнопок по умолчанию
boolean upSwitchState = 0;
boolean downSwitchState = 0;
boolean cancelSwitchState = 0;
boolean okSwitchState = 0;
//переменные для кнопок
long ms_button = 0;
boolean  button_state = false;
boolean  button_long_state = false;
//---секция кнопок---//

//---секция профиля---//
byte currentProfile = 1; //текущий профиль
byte currentStep = 1;     //текущий шаг профиля
byte profileSteps;   //количество шагов профиля
byte editStep = 0;        //номер шага профиля который редактируется в данный момент
byte rampRateStep[9];  //скорость роста температуры
byte dwellTimerStep[9];   //установленное время перехода на следующий шаг
byte temperatureStep[9]; //заданные температуры для шагов профиля ВИ
//---секция профиля---//

//---Секция флагов---//
boolean TopStart = false; //флаг включения ВИ
boolean flag = 0;         //флаг для фиксации стартовой температуры
byte x = 1;                //переменная для перехода на нужный шаг при горячей плате
boolean alarmOn = false; //признак предупреждения
boolean updateScreen = true; //признак обновления экрана
//---Секция флагов---//

//---Секция переменных общего назначения---//
byte startTemp; //стартовая температура для профиля, когда НИ вышел на уставку, используется для определения шага профиля с которого начинаем
byte setpointRamp; //заданная температура по определённому шагу профиля ВИ, связана с заданной скоростью роста температуры
byte curCount = 0;  //знакоместо звездочек (они бегают по ЭКРАНУ в режиме RUN)
byte counter;  //счётчик для рампы и счетчик для времени нахождения в шаге
unsigned long previousMillis; //это для счетчиков
#define SENSOR_SAMPLING_TIME 250 //частота обновления текущей температуры (1000=1раз в секунду)
#define GRAPHICS_SAMPLING_TIME 500 //скорость движения "звёздочек" при пайке
unsigned long nextRead2; //переменная для обновления текущей температуры и расчёта ПИД
unsigned long nextRead1; //переменная для движения "звёздочек" при пайке и подготовки данных для передачи на ПК
int tc1; //переменная для хранения текущей температуры ВИ
int tc2; //переменная для хранения текущей температуры НИ
byte Secs = 0; //это для графиков на ПК
int i = 0;
//---Секция переменных общего назначения---//

//---структура статусов событий---//
// ***** TYPE DEFINITIONS *****
typedef enum REFLOW_STATE : byte
{
  REFLOW_STATE_IDLE,
  REFLOW_STATE_MENU_STEPS,
  REFLOW_STATE_MENU_BOTTOM_HEAT,
  REFLOW_STATE_MENU_BOTTOM_PWR,
  REFLOW_STATE_MENU_STEP_RAMP,
  REFLOW_STATE_MENU_STEP_TARGET,
  REFLOW_STATE_MENU_TOP_PWR,
  REFLOW_STATE_MENU_STEP_DWELL,
  REFLOW_STATE_MENU_BOTTOM_P,
  REFLOW_STATE_MENU_BOTTOM_I,
  REFLOW_STATE_MENU_BOTTOM_D,
  REFLOW_STATE_MENU_TOP_P,
  REFLOW_STATE_MENU_TOP_I,
  REFLOW_STATE_MENU_TOP_D,
  REFLOW_STATE_STEP_RAMP,
  REFLOW_STATE_STEP,
  REFLOW_STATE_STEP_DWELL,
  REFLOW_STATE_COMPLETE,
  REFLOW_STATE_ERROR
}
reflowState_t;

typedef enum REFLOW_STATUS : byte  //структура статуса пайки, запущен или нет
{
  REFLOW_STATUS_OFF,
  REFLOW_STATUS_ON
}
reflowStatus_t;

reflowStatus_t reflowStatus;  //переменная статусов событий
reflowState_t reflowState;  //переменная статуса пайки
//---структура статусов событий---//


#define buzzerPin 3 //назначаем пин пищалки
#define Int_Fan  8  //назначаем пин охладителя симисторов и контроллера
#define Ext_Fan  13  //назначаем пин охладителя платы


//---секция преобразователей термопар---//
//назначаем пины подключения преобразователей термопар
#define thermoSO  4 //DO
#define thermoCLK  5 //SCK
#define thermoCStop  6 //CS
#define thermoCSbott  7 //CS
//---секция преобразователей термопар---//


void loadProfile() //чтение профиля из EEPROM
{
  profileSteps = EEPROM.read((currentProfile - 1) * 37);
  Setpoint2 = 80 + EEPROM.read((currentProfile - 1) * 37 + 1);
  for (int i = 0; i < 9; i++) {
    rampRateStep[i] = EEPROM.read((currentProfile - 1) * 37 + i + 2);
    dwellTimerStep[i] = EEPROM.read((currentProfile - 1) * 37 + i + 11) * 5;
    temperatureStep[i] = EEPROM.read((currentProfile - 1) * 37 + i + 20);
  }
  kp1 = EEPROM.read((currentProfile - 1) * 37 + 29);
  ki1 = EEPROM.read((currentProfile - 1) * 37 + 30);
  kd1 = EEPROM.read((currentProfile - 1) * 37 + 31);
  kp2 = EEPROM.read((currentProfile - 1) * 37 + 32);
  ki2 = EEPROM.read((currentProfile - 1) * 37 + 33);
  kd2 = EEPROM.read((currentProfile - 1) * 37 + 34);
  pwr_TOP = EEPROM.read((currentProfile - 1) * 37 + 35);
  pwr_BOTTOM = EEPROM.read((currentProfile - 1) * 37 + 36);

  return;
}


void initEeprom()//Запись в память начальных значений
{
  if (EEPROM.read(1023) == 'C')
  {
    // чтото только для уже инициализированой памяти
  }
  else {
    // профиль: шаги, температура низа-80
    static byte rom[] = {   3, 70,
                            //9 скоростей роста температуры
                            4, 2, 4, 4, 4, 4, 4, 4, 4,
                            // 9 продолжительностей шага
                            5, 5, 15, 1, 1, 1, 1, 1, 1,
                            // температуры верхнего нагревателя по 9 шагам
                            150, 180, 190, 190, 205, 210, 215, 220, 225,
                            // PID верха,
                            55, 7, 30,
                            // PID низа,
                            63, 3, 30,
                            // ограниченеи мощности верха и низа в процентах
                            40, 85
                        };
    for (byte j = 0; j < 14; j++)
    {
      for (byte i = 0; i < 37; i++)
      {
        EEPROM.write(j * 37 + i, rom[i]);
      }
    }
    EEPROM.write(1023, 'C');
  }
}


void setup()
{
  //Записываем единицы в EEPROM для избавления от глюков. Закомментировать после разового запуска
  //for (int i = 0; i < 1024; i++)
  //EEPROM.write(i, 1);

  Serial.begin(9600);

  loadProfile(); //вызов функции loadProfile для загрузки данных профиля из eeprom

    attachInterrupt(0, Dimming, RISING); // настроить порт прерывания(0 или 1) 2й цифровой пин
    /* -------------------------------------------------------------------------------
      LOW вызывает прерывание, когда на порту LOW
      CHANGE прерывание вызывается при смене значения на порту, с LOW на HIGH и наоборот
      RISING прерывание вызывается только при смене значения на порту с LOW на HIGH
      FALLING прерывание вызывается только при смене значения на порту с HIGH на LOW
      ------------------------------------------------------------------------------- */
      
  
  tft.begin();
  tft.setRotation(3);
  tft.fillRect(0, 0, 320, 240, Bgcolor);//lcd.clear();
  tft.setCursor(20, 5);
  tft.setTextColor(ILI9341_NAVY);  tft.setTextSize(3);
  tft.println("1v01  TFT  NANO");
  tft.setTextColor(ILI9341_DARKGREEN, Bgcolor);  tft.setTextSize(3);


  // colors ILI9341
  // ILI9341_BLACK       0x0000      /*   0,   0,   0 */
  // ILI9341_NAVY        0x000F      /*   0,   0, 128 */
  // ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
  // ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
  // ILI9341_MAROON      0x7800      /* 128,   0,   0 */
  // ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
  // ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
  // ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
  // ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
  // ILI9341_BLUE        0x001F      /*   0,   0, 255 */
  // ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
  // ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
  // ILI9341_RED         0xF800      /* 255,   0,   0 */
  // ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
  // ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
  // ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
  // ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
  // ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
  // ILI9341_PINK        0xF81F


  //устанавливаем пины кнопок на ВХОД и подключаем подтягивающие резисторы
  pinMode (upSwitchPin, INPUT_PULLUP);     //подключен подтягивающий резистор
  pinMode (downSwitchPin, INPUT_PULLUP);   //подключен подтягивающий резистор
  pinMode (cancelSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  pinMode (okSwitchPin, INPUT_PULLUP);     //подключен подтягивающий резистор

  //задаём состояние пинов, к которым подключены MAX6675
  pinMode(thermoCStop, OUTPUT);
  pinMode(thermoCSbott, OUTPUT);
  pinMode(thermoCLK, OUTPUT);
  pinMode(thermoSO, INPUT);

  //устанавливаем пин пищалки на ВЫХОД
  pinMode(buzzerPin, OUTPUT);

  //устанавливаем пины охладителей на ВЫХОД
  pinMode (Int_Fan, OUTPUT);
  pinMode (Ext_Fan, OUTPUT);
  
  //задаём состояние пинов управления выходами
  pinMode(RelayPin1, OUTPUT);
  pinMode(RelayPin2, OUTPUT);


  //Мелодия приветствия
  tone(buzzerPin, 523);
  delay(200);
  tone(buzzerPin, 659);
  delay(200);
  tone(buzzerPin, 780);
  delay(200);
  tone(buzzerPin, 1046);
  delay(200);
  noTone(buzzerPin);

/*
//Гимн СССР https://clck.ru/FX6CG
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 174, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 195, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 220, 499.9995);
    delay(555.555);
    tone(buzzerPin, 146, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 146, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 499.9995);
    delay(555.555);
    tone(buzzerPin, 174, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 155, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 499.9995);
    delay(555.555);
    tone(buzzerPin, 116, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 116, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 130, 499.9995);
    delay(555.555);
    tone(buzzerPin, 130, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 146, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 155, 499.9995);
    delay(555.555);
    tone(buzzerPin, 155, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 174, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 195, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 233, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 261, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 293, 499.9995);
    delay(555.555);
    tone(buzzerPin, 261, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 233, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 261, 499.9995);
    delay(555.555);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 195, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 220, 499.9995);
    delay(555.555);
    tone(buzzerPin, 146, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 146, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 195, 499.9995);
    delay(555.555);
    tone(buzzerPin, 174, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 155, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 499.9995);
    delay(555.555);
    tone(buzzerPin, 116, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 116, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 195, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 999.999);
    delay(1111.11);
    tone(buzzerPin, 293, 999.999);
    delay(1111.11);
    tone(buzzerPin, 261, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 220, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 261, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 174, 999.999);
    delay(1111.11);
    tone(buzzerPin, 233, 999.999);
    delay(1111.11);
    tone(buzzerPin, 220, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 174, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 220, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 146, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 146, 999.999);
    delay(1111.11);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 195, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 220, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 195, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 220, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 195, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 233, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 311, 999.999);
    delay(1111.11);
    tone(buzzerPin, 311, 999.999);
    delay(1111.11);
    tone(buzzerPin, 293, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 261, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 261, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 293, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 999.999);
    delay(1111.11);
    tone(buzzerPin, 261, 999.999);
    delay(1111.11);
    tone(buzzerPin, 233, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 220, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 220, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 233, 749.99925);
    delay(833.3325);
    tone(buzzerPin, 195, 249.99975);
    delay(277.7775);
    tone(buzzerPin, 195, 999.999);
    delay(1111.11);
    tone(buzzerPin, 233, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 195, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 499.9995);
    delay(555.555);
    tone(buzzerPin, 116, 374.999625);
    delay(416.66625);
    tone(buzzerPin, 116, 124.999875);
    delay(138.88875);
    tone(buzzerPin, 174, 999.999);
    delay(1111.11);
    tone(buzzerPin, 195, 499.9995);
    delay(555.555);
    tone(buzzerPin, 220, 499.9995);
    delay(555.555);
    tone(buzzerPin, 233, 1999.998);
    delay(2222.22);
*/  
  initEeprom();
  loadProfile();  
  delay(3000);

  
  nextRead2 = millis(); //запускаем чтение с термопары ВИ
}


char buf[32]; //буфер данных для графиков на ПК

void loop()
{
  //Считываем состояние кнопок управления
  upSwitchState = !digitalRead(upSwitchPin);
  downSwitchState = !digitalRead(downSwitchPin);
  cancelSwitchState = !digitalRead(cancelSwitchPin);
  okSwitchState = !digitalRead(okSwitchPin);


  unsigned long currentMillis = millis();

  int SP2 = Setpoint2;

  //отключил бузер при нажатии на кнопки (нервирует), кому надо раскоментируйте ниже 6 строк
  //if (upSwitchState == HIGH || downSwitchState == HIGH || cancelSwitchState == HIGH || okSwitchState == HIGH)
  //{
  //  tone(buzzerPin, 1045);
  //  delay(100);
  // noTone(buzzerPin);
  //}


  if (reflowState == REFLOW_STATE_COMPLETE || alarmOn) {
    if (i < 2 && cancelSwitchState == LOW) {
      alarmOn = true;
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      i++;
    }
    else {
      i = 0;
      alarmOn = false;
    }
  }

  switch (reflowState)
  {
    case REFLOW_STATE_IDLE:
      TopStart = false;
      currentStep = 1;
      counter = 0;
      setpointRamp = 0;
      x = 1;             //устанавливаем переменную в исходное состояние
      flag = 0;         //после отановки профиля сбрасываем флаг
      Output1 = 0;
      Output2 = 0;

      if (millis() > nextRead2)
      {
        // Read thermocouples next sampling period
        nextRead2 = millis() + SENSOR_SAMPLING_TIME; //устраняем колебания датчиков температуры
        Input1 = Input1*0.6 + 0.4*(max6675_read_temp (thermoCLK, thermoCStop, thermoSO)); //термопара "ВЕРХНЕГО" нагревателя
        Input2 = Input2*0.6 + 0.4*(max6675_read_temp (thermoCLK, thermoCSbott, thermoSO)); //термопара "НИЖНЕГО"  нагревателя
        tc1 = Input1;
        tc2 = Input2;

        sprintf(buf, "$%d %d;", tc2, tc1); //график ПК


        {
          tft.setCursor(16 * 16 + 5, 2 * 48 + 48);
          tft.print("   ");
          tft.setCursor(16 * 16 + 5, 2 * 48 + 48);
          tft.print(tc1);
        }

        {
          tft.setCursor(16 * 16 + 5, 3 * 48 + 48);
          tft.print("   ");
          tft.setCursor(16 * 16 + 5, 3 * 48 + 48);
          tft.print(tc2);
        }

      }

      //Обновляем экран один раз
      if (updateScreen) {
 
        
        //Настройка экрана в режиме ожидания
        tft.fillRect(0, 48, 320, 240 - 96, Bgcolor);
        tft.setCursor(8 * 16, 0 * 48 + 48);
        tft.print("IDLE");
        tft.setCursor(1 * 16 + 2, 1 * 48 + 48);
        tft.print("PTN:      STEP:1 ");
        tft.setCursor(0 * 16, 2 * 48 + 48);
        tft.print(" TH SP:");
        tft.setCursor(13 * 16, 2 * 48 + 48);
        tft.print(char(30)); tft.print("T:   ");
        tft.setCursor(0 * 16, 3 * 48 + 48);
        tft.print(" BH SP:    ");
        tft.setCursor(13 * 16, 3 * 48 + 48);
        tft.print(char(31)); tft.print("T:   ");
        tft.setCursor(8 * 16, 3 * 48 + 48);
        tft.print(SP2);
        tft.print(" ");
        updateScreen = false;
      }
      tft.setCursor(6 * 16, 1 * 48 + 48);
      tft.print(currentProfile);
      tft.print(" ");
      tft.setCursor(8 * 16, 2 * 48 + 48);
      tft.print(temperatureStep[0]);
      tft.setCursor(8 * 16, 3 * 48 + 48);
      tft.print(SP2);
      tft.print("  ");
      tft.setCursor(13 * 16, 3 * 48 + 48);
      tft.print(char(31));


      if (upSwitchState == HIGH && ( millis() - ms_button) > 500) //когда нажата кнопка ВВЕРХ нужно перейти к следующему профилю
      {
        ms_button =  millis();
        currentProfile = currentProfile + 1;
        if (currentProfile >= 15) //если текущий профиль = 14, нужно вернуться к профилю 1
        {
          currentProfile = 1;
        }
        loadProfile(); //вызов функции loadProfile для загрузки данных профиля из eeprom
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 500) //same as above just go down one profile
      {
        ms_button =  millis();
        currentProfile = currentProfile - 1;
        if (currentProfile <= 0)
        {
          currentProfile = 14;
        }
        loadProfile(); //вызов функции loadProfile для загрузки данных профиля из eeprom
      }


      //фиксируем момент нажатия кнопки "ОК" + защита от дребезга

      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
        button_long_state = false;
      }


      //держим "ОК" 3 секунды и заходим в меню настроек
     
      if (okSwitchState == HIGH && !button_long_state && ( millis() - ms_button) > 3000)
      {
        button_long_state = true;
        button_state = false;
        reflowState = REFLOW_STATE_MENU_STEPS;
        //update next screen
        updateScreen = true;
      }


      //включаем пайку, кнопка сработает после отпускания "ОК"

      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        tone(buzzerPin, 1045, 500);  //звуковой сигнал при старте профиля
        //update next screen
        updateScreen = true;
        curCount = 0;
        nextRead1 = millis();
        nextRead2 = millis();
        reflowStatus = REFLOW_STATUS_ON;
        reflowState = REFLOW_STATE_STEP_RAMP;
      }
      break;


    //устанавливаем количество шагов профиля
    case REFLOW_STATE_MENU_STEPS:
      if (updateScreen)
      {
        tft.fillRect(0, 48, 320, 240 - 48, Bgcolor);
        tft.setCursor(0 * 16 + 5, 0 * 48 + 48);
        tft.print("Profile:");
        tft.setCursor(10 * 16, 0 * 48 + 48);
        tft.print(currentProfile);
        tft.setCursor(13 * 16, 0 * 48 + 48);
        tft.print("Edit");
        tft.setCursor(0 * 16 + 5, 2 * 48 + 48);
        tft.print("Profile Steps:    " );
        tft.setCursor(16 * 16, 2 * 48 + 48);
        tft.print(profileSteps);
        updateScreen = false;
      }
      tft.setCursor(16 * 16, 2 * 48 + 48);
      tft.print(profileSteps);

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profileSteps = profileSteps + 1;
        if (profileSteps >= 10) {
          profileSteps = 1;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        profileSteps = profileSteps - 1;
        if (profileSteps <= 0)
        {
          profileSteps = 9;
        }
      }
      if (okSwitchState == LOW && button_long_state) button_long_state = false; //чтобы после входа в меню кнопка "ОК" не считалась нажатой

      if (okSwitchState == HIGH && !button_state && !button_long_state && ( millis() - ms_button) > 100)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        EEPROM.write((currentProfile - 1) * 37, profileSteps);        
        reflowState = REFLOW_STATE_MENU_BOTTOM_HEAT;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;


    //устанавливаем температуру "Нижнего Нагревателя"
    case REFLOW_STATE_MENU_BOTTOM_HEAT:

      if (updateScreen) 
      {
        tft.setCursor(0 * 16, 1 * 48 + 48); 
        tft.print(" SET TEMP Bottom   ");
        tft.setCursor(0 * 16 + 5, 2 * 48 + 48); 
        tft.print("Bottom Heat:   ");
        updateScreen = false;
      }
      tft.setCursor(15 * 16, 2 * 48 + 48);
      tft.print(SP2);
      tft.print(" ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        Setpoint2 = Setpoint2 + 10;
        if (Setpoint2 >= 330)
        {
          Setpoint2 = 330;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        Setpoint2 = Setpoint2 - 10;
        if (Setpoint2 <= 80)
        {
          Setpoint2 = 80;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        EEPROM.write((currentProfile - 1) * 37 + 1, (Setpoint2 - 80) );        
        reflowState = REFLOW_STATE_MENU_BOTTOM_PWR;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;


    //устанавливаем максимальную мощность "НИЖНЕГО НАГРЕВАТЕЛЯ"
    case REFLOW_STATE_MENU_BOTTOM_PWR:

      if (updateScreen)
      {
        tft.setCursor(0 * 16 + 5, 2 * 48 + 48);
        tft.print("Bottom PWR:    ");
        updateScreen = false;
      }
      tft.setCursor(14 * 16, 2 * 48 + 48);
      tft.print(pwr_BOTTOM);
      tft.print("%  ");
 
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        pwr_BOTTOM = pwr_BOTTOM + 1;
        if (pwr_BOTTOM >= 100)
        {
          pwr_BOTTOM = 100;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();

        if (pwr_BOTTOM >= 1) pwr_BOTTOM = pwr_BOTTOM - 1;
        else  pwr_BOTTOM = 0;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        EEPROM.write(((currentProfile - 1) * 37 + 36), pwr_BOTTOM);        
        reflowState = REFLOW_STATE_MENU_TOP_PWR;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;


    //устанавливаем максимальную мощность "ВЕРХНЕГО НАГРЕВАТЕЛЯ"
    case REFLOW_STATE_MENU_TOP_PWR:

      if (updateScreen)
      {
        tft.setCursor(0 * 16 + 5, 2 * 48 + 48);
        tft.print("   TOP PWR:     ");
        updateScreen = false;
      }
      tft.setCursor(14 * 16, 2 * 48 + 48);
      tft.print(pwr_TOP);
      tft.print("%  ");
 
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        pwr_TOP = pwr_TOP + 1;
        if (pwr_TOP >= 100)
        {
          pwr_TOP = 100;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();

        if (pwr_TOP >= 1) pwr_TOP = pwr_TOP - 1;
        else (pwr_TOP = 0);
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        EEPROM.write(((currentProfile - 1) * 37 + 35), pwr_TOP);        
        reflowState = REFLOW_STATE_MENU_STEP_RAMP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;


    //устанавливаем скорость нагрева "Верхним Нагревателем"
    case REFLOW_STATE_MENU_STEP_RAMP:

      if (updateScreen) 
      {
        tft.setCursor(0 * 16, 1 * 48 + 48);
        tft.print(" TEMP SPEED "); tft.print(char(31)); tft.print("     ");
        tft.setCursor(0 * 16 + 5, 2 * 48 + 48); 
        tft.print("Step:  Ramp:       "); 
        tft.setCursor(6 * 16 + 5, 2 * 48 + 48);
        tft.print(editStep + 1);
        updateScreen = false;
      }
      tft.setCursor(14 * 16, 2 * 48 + 48);
      tft.print(rampRateStep[editStep]);
      tft.print(" ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        rampRateStep[editStep] = rampRateStep[editStep] + 1;
        if (rampRateStep[editStep] >= 30)  //(только целые числа) максимальная скорость роста температуры умноженная на 10
        {
          rampRateStep[editStep] = 30;  //(только целые числа) максимальная скорость роста температуры умноженная на 10
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        rampRateStep[editStep] = rampRateStep[editStep] - 1;
        if (rampRateStep[editStep] <= 1)  //(только целые числа) минимальная скорость роста температуры умноженная на 10
        {
          rampRateStep[editStep] = 1;  //(только целые числа) минимальная скорость роста температуры умноженная на 10
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {
          editStep = 0;
          for (byte i = 0; i < 9; i++) EEPROM.write(((currentProfile - 1) * 37 + i + 2), rampRateStep[i] );          
          reflowState = REFLOW_STATE_MENU_STEP_TARGET;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;


    //устанавливаем температуру "Верхнего Нагревателя"
    case REFLOW_STATE_MENU_STEP_TARGET:
      if (updateScreen) 
      {
        tft.setCursor(0 * 16, 1 * 48 + 48);
        tft.print(" SET Top TEMP      ");
        tft.setCursor(0 * 16 + 5, 2 * 48 + 48);
        tft.print("Step:   ");
        tft.print(char(30));
        tft.print("TEMP:   ");
        tft.setCursor(6 * 16 + 5, 2 * 48 + 48);
        tft.print(editStep + 1);
        tft.setCursor(16 * 16, 2 * 48 + 48);
        tft.print(temperatureStep[editStep]);
        tft.print("  ");
        updateScreen = false;
      }
      tft.print("  ");
      tft.setCursor(16 * 16, 2 * 48 + 48);
      tft.print(temperatureStep[editStep]);
      tft.print("  ");
 
      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        temperatureStep[editStep] = temperatureStep[editStep] + 1;
        if (temperatureStep[editStep] >= 255)
        {
          temperatureStep[editStep] = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        temperatureStep[editStep] = temperatureStep[editStep] - 1;
        if (temperatureStep[editStep] <= 0)
        {
          temperatureStep[editStep] = 0;
        }
      }

      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {
          editStep = 0;
          for (int i = 0; i < 9; i++) EEPROM.write(((currentProfile - 1) * 37 + i + 20), temperatureStep[i]);          
          reflowState = REFLOW_STATE_MENU_STEP_DWELL;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;


    //устанавливаем время перехода на следующий шаг
    case REFLOW_STATE_MENU_STEP_DWELL:
     if (updateScreen) 
     {
        tft.setCursor(0 * 16, 1 * 48 + 48);
        tft.print(" Time next step   ");
        tft.setCursor(0 * 16 + 5, 2 * 48 + 48);
        tft.print("Step:");
        tft.print(editStep + 1);
        tft.print(" ");
        tft.setCursor(9 * 16, 2 * 48 + 48);
        tft.print("Time: ");
        tft.setCursor(15 * 16, 2 * 48 + 48);
        tft.print(dwellTimerStep[editStep]);
        tft.print("     ");
      }
      tft.setCursor(15 * 16, 2 * 48 + 48);
      tft.print(dwellTimerStep[editStep]);
      tft.print("     ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        dwellTimerStep[editStep] = dwellTimerStep[editStep] + 5;
        if (dwellTimerStep[editStep] >= 180)
        {
          dwellTimerStep[editStep] = 180;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();

        if (dwellTimerStep[editStep] >= 5) dwellTimerStep[editStep] = dwellTimerStep[editStep] - 5;
        else dwellTimerStep[editStep] = 0;
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        if (editStep + 1 == profileSteps) {

          editStep = 0;
          for (int i = 0; i < 9; i++) EEPROM.write(((currentProfile - 1) * 37 + i + 11), dwellTimerStep[i] / 5);          
          reflowState = REFLOW_STATE_MENU_BOTTOM_P;
        }
        else {
          editStep++;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        editStep = 0;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;


    //настройка "ПИД" нижнего нагревателя
    case REFLOW_STATE_MENU_BOTTOM_P:
      if (updateScreen) 
      {
        tft.setCursor(0 * 16, 1 * 48 + 48);
        tft.print("        PID        ");
        tft.setCursor(0 * 16 + 5, 2 * 48 + 48);
        tft.print("                  ");
        tft.setCursor(1 * 16, 2 * 48 + 48);
        tft.print("Bottom Heater:");
        tft.setCursor(8 * 16, 3 * 48 + 48);
        tft.print("P= ");
        tft.setCursor(11 * 16, 3 * 48 + 48);
        tft.print(kp2);
        tft.print("  ");
        updateScreen = false;
      }
      tft.setCursor(11 * 16, 3 * 48 + 48);
      tft.print(kp2);
      tft.print("  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        kp2 = kp2 + 1;
        if (kp2 >= 255)
        {
          kp2 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        kp2 = kp2 - 1;
        if (kp2 <= 0)
        {
          kp2 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        EEPROM.write(((currentProfile - 1) * 37 + 32), kp2);        
        reflowState = REFLOW_STATE_MENU_BOTTOM_I;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    case REFLOW_STATE_MENU_BOTTOM_I:
      tft.setCursor(0 * 16, 1 * 48 + 48);
      tft.print("        PID        ");
      tft.setCursor(8 * 16, 3 * 48 + 48);
      tft.print("I= ");
      tft.setCursor(11 * 16, 3 * 48 + 48);
      tft.print(ki2);
      tft.print("  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        ki2 = ki2 + 1;
        if (ki2 >= 255)
        {
          ki2 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        ki2 = ki2 - 1;
        if (ki2 <= 0)
        {
          ki2 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        EEPROM.write(((currentProfile - 1) * 37 + 33), ki2);        
        reflowState = REFLOW_STATE_MENU_BOTTOM_D;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    case REFLOW_STATE_MENU_BOTTOM_D:
      tft.setCursor(0 * 16, 1 * 48 + 48);
      tft.print("        PID        ");
      tft.setCursor(8 * 16, 3 * 48 + 48); 
      tft.print("D= ");
      tft.setCursor(11 * 16, 3 * 48 + 48);
      tft.print(kd2);
      tft.print("  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        kd2 = kd2 + 1;
        if (kd2 >= 255)
        {
          kd2 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        kd2 = kd2 - 1;
        if (kd2 <= 0)
        {
          kd2 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        EEPROM.write(((currentProfile - 1) * 37 + 34), kd2);        
        reflowState = REFLOW_STATE_MENU_TOP_P;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;


    //настройка "ПИД" верхнего нагревателя
    case REFLOW_STATE_MENU_TOP_P:
      if (updateScreen) 
      {
        tft.setCursor(0 * 16, 1 * 48 + 48);
        tft.print("        PID        "); 
        tft.setCursor(0 * 16 + 5, 2 * 48 + 48);
        tft.print("                  ");
        tft.setCursor(3 * 16, 2 * 48 + 48);
        tft.print("TOP Heater:   ");
        tft.setCursor(8 * 16, 3 * 48 + 48);
        tft.print("P= ");
        tft.setCursor(11 * 16, 3 * 48 + 48);
        tft.print(kp1);
        tft.print("  ");
        updateScreen = false;
      }
      tft.setCursor(11 * 16, 3 * 48 + 48);
      tft.print(kp1);
      tft.print("  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        kp1 = kp1 + 1;
        if (kp1 >= 255)
        {
          kp1 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        kp1 = kp1 - 1;
        if (kp1 <= 0)
        {
          kp1 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        EEPROM.write(((currentProfile - 1) * 37 + 29), kp1);        
        reflowState = REFLOW_STATE_MENU_TOP_I;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        updateScreen = true;
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    case REFLOW_STATE_MENU_TOP_I:
      tft.setCursor(0 * 16, 1 * 48 + 48);
      tft.print("        PID        ");
      tft.setCursor(8 * 16, 3 * 48 + 48);
      tft.print("I= ");
      tft.setCursor(11 * 16, 3 * 48 + 48);
      tft.print(ki1);
      tft.print("  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        ki1 = ki1 + 1;
        if (ki1 >= 255)
        {
          ki1 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        ki1 = ki1 - 1;
        if (ki1 <= 0)
        {
          ki1 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        EEPROM.write(((currentProfile - 1) * 37 + 30), ki1);        
        reflowState = REFLOW_STATE_MENU_TOP_D;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;

    case REFLOW_STATE_MENU_TOP_D:
      tft.setCursor(0 * 16, 1 * 48 + 48);
      tft.print("        PID        ");
      tft.setCursor(8 * 16, 3 * 48 + 48);
      tft.print("D=");
      tft.setCursor(11 * 16, 3 * 48 + 48);
      tft.print(kd1);
      tft.print("  ");

      if (upSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        kd1 = kd1 + 1;
        if (kd1 >= 255)
        {
          kd1 = 255;
        }
      }
      if (downSwitchState == HIGH && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        kd1 = kd1 - 1;
        if (kd1 <= 0)
        {
          kd1 = 0;
        }
      }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = true;
      }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button) > 200)
      {
        ms_button =  millis();
        button_state = false;
        EEPROM.write(((currentProfile - 1) * 37 + 31), kd1);        

        reflowState = REFLOW_STATE_IDLE;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        reflowState = REFLOW_STATE_IDLE;
      }
      break;


    //"процесс пайки", рост температуры с заданной скоростью
    case REFLOW_STATE_STEP_RAMP:
      digitalWrite(Int_Fan, HIGH); //включить охладитель симисторов и контроллера
      if (updateScreen) {
        tft.setTextColor(ILI9341_NAVY, Bgcolor);
        tft.setCursor(8 * 16, 0 * 48 + 48);
        tft.print("RUN!");
        tft.setTextColor(ILI9341_DARKGREEN, Bgcolor);
        updateScreen = false;      
      }

      if (tc1 >= Setpoint2 - 2 && !TopStart) TopStart = true; //если низ достиг уставки минус 2*С, включаем верхний нагреватель

      if (TopStart == true)  // включаем верхний нагреватель
   //-------------------------------------------------------------------------------------------
  { //открываем скобку (чтоб не запутаться)

        //фиксируем стартовую температуру
        if (flag == 0)
        {
          startTemp = tc1;
          flag = 1;
        }

      //устанавливаем нужный шаг, до которой нагрета плата
      if (startTemp > temperatureStep[currentStep - 1]) 
      {
        for (x = 1; startTemp > temperatureStep[currentStep - 1]; currentStep++) {
          x++;
        }
      }
      if (currentStep > x && flag == 1) {
        flag = 0;
        startTemp = temperatureStep[currentStep - 2];
        flag = 1;
      }
      tft.setCursor(18 * 16, 1 * 48 + 48);
      tft.print(currentStep);
      tft.setCursor(8 * 16, 3 * 48 + 48);
      tft.print(SP2);

      //счётчик скорости роста температуры
      if ((currentMillis - previousMillis) > 1000 / (rampRateStep[currentStep - 1] * 0.1)) //скорость роста температуры от 0.1с. до 3с.

      {
        previousMillis = currentMillis;
        counter = counter + 1;
        setpointRamp = counter + startTemp;
        tft.setCursor(8 * 16, 2 * 48 + 48);
        tft.print("   ");
        tft.setCursor(8 * 16, 8 * 48 + 48);
        tft.print(setpointRamp); 
        tft.print("  ");
        Setpoint1 = setpointRamp;
      }
  } //закрывам скобку
  //----------------------------------------------------------------------------------------

      if (setpointRamp >= temperatureStep[currentStep - 1]) //если достигли нужной температуры
      {
        tft.setCursor(8 * 16, 2 * 48 + 48);
        tft.print(temperatureStep[currentStep - 1]);
        reflowState = REFLOW_STATE_STEP;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        digitalWrite(Int_Fan, LOW); //выключить охладитель симисторов и контроллера
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
        updateScreen = true;
      }
      break;
      
    case REFLOW_STATE_STEP:
      Setpoint1 = temperatureStep[currentStep - 1];
      if (Input1 >= temperatureStep[currentStep - 1])
      {
        counter = 0;
        reflowState = REFLOW_STATE_STEP_DWELL;
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        digitalWrite(Int_Fan, LOW); //выключить охладитель симисторов и контроллера
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;      
        updateScreen = true;
       }
      break;


    //считаем время перехода на следующий шаг
    case REFLOW_STATE_STEP_DWELL:
      if (currentMillis - previousMillis > 1000)
      {
        previousMillis = currentMillis;
        counter = counter + 1;
      }
      if (counter == dwellTimerStep[currentStep - 1]) //если счётчик равен установленному времени
      {
        counter = 0;
        setpointRamp = 0;
        if (profileSteps == currentStep) //если достигли последнего шага
        {
          currentStep = 1;
          x = 1;      //устанавливаем переменную в исходное состояние
          flag = 0;   //после завершения профиля сбрасываем флаг
          reflowState = REFLOW_STATE_COMPLETE;
        }
        else //если шаг не последний
        {
          currentStep++; //переходим на следующий шаг
          reflowState = REFLOW_STATE_STEP_RAMP;
        }
      }
      if (cancelSwitchState == HIGH && ( millis() - ms_button) > 50)
      {
        ms_button =  millis();
        digitalWrite(Int_Fan, LOW); //выключить охладитель симисторов и контроллера
        reflowStatus = REFLOW_STATUS_OFF;
        reflowState = REFLOW_STATE_IDLE;
        updateScreen = true;
      }
      break;


    //завершение пайки
    case REFLOW_STATE_COMPLETE:
      digitalWrite(Ext_Fan, HIGH); //включить охладитель платы
      digitalWrite(Int_Fan, LOW); //выключить охладитель симисторов и контроллера
      reflowStatus = REFLOW_STATUS_OFF;
      reflowState = REFLOW_STATE_IDLE;
      updateScreen = true;
      break;
  }


  //включение нагревателей
  if (reflowStatus == REFLOW_STATUS_ON)
  {
    if (millis() > nextRead1)
    {
     //двигаем звездочки по экрану
      nextRead1 = millis() + GRAPHICS_SAMPLING_TIME;
      sprintf(buf, "$%d %d;", tc2, tc1); //график ПК
      if (curCount <= 7)
      {
        tft.setTextColor(ILI9341_MAGENTA, Bgcolor);
        tft.setTextSize(2);
        tft.setCursor(curCount * 12, 0 * 48 + 48);
        tft.print(" *");
        tft.setCursor((24 - curCount) * 12, 0 * 48 + 48);
        tft.print("* ");
        tft.setTextSize(3);
        tft.setTextColor(ILI9341_DARKGREEN, Bgcolor);
      }
      if (curCount > 7)
      {
        tft.setTextColor(ILI9341_MAGENTA, Bgcolor);
        tft.setTextSize(2);
        tft.setCursor((15 - curCount) * 12, 0 * 48 + 48);
        tft.print("* "); //lcd.print("* ");
        tft.setCursor((curCount + 9) * 12, 0 * 48 + 48);
        tft.print(" *");
        tft.setTextSize(3);
        tft.setTextColor(ILI9341_DARKGREEN, Bgcolor);
      }
      curCount++;
      if (curCount > 14) curCount = 0;
    }
    if (millis() > nextRead2)
    {
      //считываем данные с термопар и считаем ПИД
        Input1 = Input1*0.6 + 0.4*(max6675_read_temp (thermoCLK, thermoCStop, thermoSO)); //термопара "ВЕРХНЕГО" нагревателя
        Input2 = Input2*0.6 + 0.4*(max6675_read_temp (thermoCLK, thermoCSbott, thermoSO)); //термопара "НИЖНЕГО"  нагревателя
      tc1 = Input1;
      tc2 = Input2;
      if (TopStart) Output1 = Pid1(Input1, Setpoint1, kp1, ki1, kd1); else Output1 = 0;
      Output2 = Pid2(Input2, Setpoint2, kp2, ki2, kd2);
      nextRead2 = millis() + SENSOR_SAMPLING_TIME;
      tft.setTextSize(3);
      tft.setCursor(16 * 16 + 5, 2 * 48 + 48);
      tft.print("   ");
      tft.setCursor(16 * 16 + 5, 2 * 48 + 48);
    if (isnan(Input1)) {
    tft.print("Er");
    } else {    
      tft.print(tc1);
    }      
      tft.setCursor(16 * 16 + 5, 3 * 48 + 48);   
      tft.print("   ");
      tft.setCursor(16 * 16 + 5, 3 * 48 + 48);
    if (isnan(Input2)) {      
    tft.print("Er");
    } else {          
      tft.print(tc2);      
    }
   } 
  } 
  else
  {
    digitalWrite(RelayPin1, LOW);
    digitalWrite(RelayPin2, LOW);
  }
}


void Dimming()
{
  if (reflowStatus == REFLOW_STATUS_ON)
   {
  OutPWR_TOP();
  OutPWR_BOTTOM();
  }
  if (Secs >= 100)
  {
    Serial.println(buf);
    Secs = 0;
  } else Secs++;
}

void OutPWR_TOP()
{
  reg1 = Output1 + er1; //pwr- задание выходной мощности в %, er- ошибка округления
  if (reg1 < 50)
  {
    out1 = LOW;

    er1 = reg1 ; // reg- переменная для расчетов
  }
  else
  {
    out1 = HIGH;

    er1 = reg1 - 100;
  }
  digitalWrite(RelayPin1, out1); //пин через который осуществляется дискретное управление
}

void OutPWR_BOTTOM()
{
  reg2 = Output2 + er2; //pwr- задание выходной мощности в %, er- ошибка округления
  if (reg2 < 50)
  {
    out2 = LOW;

    er2 = reg2 ; // reg- переменная для расчетов
  }
  else
  {
    out2 = HIGH;

    er2 = reg2 - 100;
  }
  digitalWrite(RelayPin2, out2); //пин через который осуществляется дискретное управление
  //i++;
}

byte Pid1(double temp, byte ust, byte kP, byte kI, byte kd)
{
  byte out = 0;
  static float ed = 0;
  float e, p;
  float d;
  e = (ust - temp); //ошибка регулирования
  p =  (kP * e); //П составляющая
  integra = (integra < i_min) ? i_min : (integra > i_max) ? i_max : integra + (kI * e) / 100; //И составляющая
  d = kd * (e - ed) * 10; //Д составляющая
  ed = e;
  out = (p + integra + d < 0) ? 0 : (p + integra + d > pwr_TOP) ? pwr_TOP : p + integra + d;
  return out;
}

byte Pid2(double temp, byte ust, byte kP, byte kI, byte kd)
{
  byte out = 0;
  static float ed = 0;
  float e, p;
  float d;
  e = (ust - temp); //ошибка регулирования
  p =  (kP * e); //П составляющая
  integra2 = (integra2 < i_min) ? i_min : (integra2 > i_max) ? i_max : integra2 + (kI * e) / 100; //И составляющая
  d = kd * (e - ed) * 10; //Д составляющая
  ed = e;
  out = (p + integra2 + d < 0) ? 0 : (p + integra2 + d > pwr_BOTTOM) ? pwr_BOTTOM : p + integra2 + d;
  return out;
}
